#include "real.h"

extern int             PLOT_ON ;
struct flist   *file_list = 0;

/*
 * make a file name from string and current node number 
 */

static char*
make_fname (s, n)
char * s;
int n;
{
    static char     buf[32];

    sprintf (buf, "%s%d", s, n);
    return buf;
}

struct flist
{
    char           *name;
    FILE           *file;
    struct flist   *next;
};


/* 
 * try to open a file, and cache its file descriptor.
 * if not open, open it
 */

static FILE*
fopen_and_cache (name)
char * name;
{
    FILE           *f;
    struct flist   *p;

    p = file_list;
    while (p)
    {
	if (strcmp (p->name, name) == 0)
	    return p->file;
	p = p->next;
    }
    f = fopen (name, "w");
    if (f == 0)
    {
	/* Maybe there are too many open files. Trying closing one. (This
	 * probably doesn't happen.) */
	if (file_list == 0)
	    pr_error ("can't open plot file");
	fclose (file_list->file);
	f = fopen (name, "w");
	if (f == 0)
	    pr_error ("can't open plot file");
	p = file_list;
	file_list = file_list->next;
	free ((void *) p);
    }
    p = (struct flist *) malloc (sizeof (*p));
    p->name = malloc (strlen (name) + 1);
    strcpy (p->name, name);
    p->file = f;
    p->next = file_list;
    file_list = p;
    return f;
}

close_all_files()
{
struct flist * p;

    p = file_list;
    while(p) {
	fclose(p->file);
	p = p->next;
    }
}


make_plot (name, data)
    char           *name;
    int             data;
{
    timev           now;
    FILE           *f;
    int             node;

    if (!PLOT_ON)
	return;

    node = get_node_id ();
    if (!plot_option[node])
	return;

    f = fopen_and_cache (make_fname (name, node));
    now = runtime ();
    fprintf (f, "%f %d\n", make_float(now), data);
}

make_flt_plot (name, data)
    char           *name;
    float           data;
{
    timev           now;
    FILE           *f;
    int             node;

    if (!PLOT_ON)
	return;

    node = get_node_id ();
    if (!plot_option[node])
	return;

    f = fopen_and_cache (make_fname (name, node));
    now = runtime ();
    fprintf (f, "%f %f\n", make_float(now), data);
}
