case $CONFIG in
'')
    if test ! -f config.sh; then
	(echo "Can't find config.sh."; exit 1)
    fi
    . config.sh
    ;;
esac
: This forces SH files to create target in same directory as SH file.
: This is so that make depend always knows where to find SH derivatives.
case "$0" in
*/*) cd `expr X$0 : 'X\(.*\)/'` ;;
esac
echo "Extracting Makefile (with variable substitutions)"
cat >Makefile <<!GROK!THIS!
#
# Makefile for Nest 2.5 (modified)
#
# This Makefile is generated by Configure from Makefile.SH.  Feel free to
# modify this Makefile; however, any changes made will be lost the next time
# you run Configure.  For more permanent changes, edit Makefile.SH instead.
# 
# If you are running a system that only supports shared objects 
# (such as IRIX > 5.2, you will need to uncomment the line in target 'all'
# For Solaris, I recommend using -a -dn flags, which avoids shared
# objects

# Configuration options

INC = $inc
LIB = $lib
LLIB = $lintlib

DEFS =
CPPFLAGS = $(DEFS) 
OPTFLAGS = -g -D_BSD_SIGNALS $d_cckr -c


# Standard Make variables

SHELL = /bin/sh

CC = cc
CFLAGS = \$(OPTFLAGS)

LINT = lint
LINTFLAGS = -buxz

CPP = $cpp $cppminus
AS = as

LD = ld
LDFLAGS =
LIBS = 

RANLIB = $ranlib
!GROK!THIS!

if $test -f /usr/include/make/default.mk
then
cat >>Makefile <<'!NO!SUBS!'

# File groups

!NO!SUBS!
else
cat >>Makefile <<'!NO!SUBS!'

CFLAGS = $(OPTFLAGS) $(CPPFLAGS) 

# Additional rules for assembler source files

.SUFFIXES: .S

.S.o:
	#$(CPP) $(CPPFLAGS) < $< | grep -v '^#' > $*.s
	$(AS) $(ASFLAGS) $(TARGET_ARCH) -o $@ $*.s
	@rm -f $*.s

# File groups

!NO!SUBS!
fi


cat >>Makefile <<'!NO!SUBS!'

# File groups

public = dcctime.h nest.h graph.h

headers = defs.h dccsig.h simulate.h process.h schedule.h \
	  message.h network.h state.h swap.h

csource = simulate.c server.c store.c swap.c timers.c sendm.c \
	  messes.c network.c procs.c scheds.c sched2s.c errors.c 

asource = state.S

nestobj = simulate.o server.o store.o swap.o timers.o sendm.o \
	  messes.o network.o procs.o scheds.o sched2s.o errors.o \
	  state.o

functns = nestargs.c recvm.c recvmt.c \
	  bcast.c anymess.c advance.c stoptime.c slumber.c runtime.c \
	  getnbrs.c compat.c

funcobj = nestargs.o recvm.o recvmt.o \
	  bcast.o anymess.o advance.o stoptime.o slumber.o runtime.o \
	  getnbrs.o compat.o

lib = nest.a

lintlib = llib-lnest.ln

addedbyconf = UU Makefile Makefile.bak makelib makedepend kit*isdone all \
	 config.h nest.h siglist.h

.PRECIOUS: $(lib)


all: $(public) $(lib) 
	touch all
# uncomment this line for SGI IRIX version >= 5.2, comment for all others
# must comment for solaris
#	ld -shared -all nest.a -o nest.so


# Build nest library with makelib

nest.a:	$(funcobj) makelib $(nestobj)
	makelib rc nest.a $(funcobj) $(nestobj)

# Build lint library

llib-lnest.ln: $(public) $(headers) $(csource) $(functns)
	$(LINT) -Cnest $(CPPFLAGS) $(csource) $(functns)

# Automatically built include file

siglist.h: siglist.awk /usr/include/signal.h
	if test -f /usr/include/sys/signal.h; then \
		awk -f siglist.awk /usr/include/sys/signal.h > siglist.h; \
	else \
		awk -f siglist.awk /usr/include/signal.h > siglist.h; \
	fi
	@ echo " "
	@ echo "The signal descriptions in siglist.h have been generated from"
	@ echo "the comments in <signal.h>.  You may want to edit them."
	@ echo " "

clean:
	rm -f *.o core core.* errs

realclean:
	rm -rf *.o core core.* errs $(addedbyconf) $(example) $(lib) $(lintlib)

lint:
	$(LINT) $(LINTFLAGS) $(CPPFLAGS) $(csource) $(functns)

listing: $(public) $(headers) $(csource) $(asource) $(functns) callgraph
	enscript -2r -F Helvetica-Bold10 -f Courier7 \
	$(public) $(headers) $(csource) $(asource) $(functns)
	enscript -r -F Helvetica-Bold10 -f Courier7 callgraph

callgraph: $(public) $(headers) $(csource) $(functns)
	cflow -i_ $(csource) $(functns) > callgraph

tags:	$(public) $(headers) $(csource) $(functns)
	ctags -t $(csource) $(functns)
	etags -et $(csource) $(functns)

depend: $(csource) $(functns) makedepend siglist.h
	./makedepend $(csource) $(functns) > depends
	echo '/^# DO NOT DELETE THIS LINE/+2,$$d' >eddep
	echo '$$r depends' >>eddep
	echo 'w' >>eddep
	cp Makefile Makefile.bak
	ed - Makefile < eddep
	rm -f eddep depends
	echo '' >> Makefile
	echo '# DEPENDENCIES MUST END AT END OF FILE' >> Makefile
	echo '# IF YOU PUT STUFF HERE IT WILL GO AWAY' >> Makefile
	echo '# see make depend above' >> Makefile

# DO NOT DELETE THIS LINE -- make depend uses it


# DEPENDENCIES MUST END AT END OF FILE
# IF YOU PUT STUFF HERE IT WILL GO AWAY
# see make depend above



!NO!SUBS!
