/*
 * Nest simulation library - simulation time advance routine
 */

#include "nest.h"

#include "defs.h"
#include "simulate.h"
#include "process.h"

/*
 * Advance simulation time on a node where time has stopped.
 */

void
advance (addtime)
timev           addtime;
{
    timev           time_temp;

    time_temp = _proc_table[_current_node].runtime;

    time_add (time_temp, addtime);      /* convert sleep time to wakeup time */

    if (_block (time_temp, ADVANCE))
        fatal ("advance: block: ");
}

void
abs_advance (abs_time)
	timev abs_time;
{
	timev time_temp;

	time_temp = _proc_table[_current_node].runtime;
	if (time_after(time_temp, abs_time))
		/* Cannot advance to an earlier time. */
		return;
	if (_block(abs_time, ADVANCE))
		fatal ("advance: block: ");
}
