/*
 * Nest simulation library - check for messages routine
 * 
 * $Header: anymess.c,v 2.5 88/03/31 14:48:43 dupuy Rel $
 */

#include "nest.h"

#include "defs.h"
#include "simulate.h"
#include "process.h"

static timev    moment = {0, 0};

/*
 * Return true if any messages waiting in queue
 */

any_messages ()
{
    timev          *result;

    if (_stop_timer (moment))           /* stop the clock while we work */
        fatal ("any_messages: stop_timer: ");

    if (not (result =                   /* no msgs before current moment */
             _check_queue (_current_node, &time_zero,
                           &_proc_table[_current_node].runtime)))
    {                                   /* block until present time */
        if (_block (_proc_table[_current_node].runtime, RECEIVE))
            fatal ("any_messages: block: ");
        result = _check_queue (_current_node, &time_zero,
                               &_proc_table[_current_node].runtime);
    }                                   /* and check again */

    if (_start_timer (time_zero))       /* start clock again and return */
        fatal ("any_messsages: start_timer: ");

    return (result isnt nil);
}
