/*
 * Nest simulation library - neighbor list routine for node functions
 * 
 * $Header: getnbrs.c,v 2.5 88/03/31 14:49:14 dupuy Rel $
 */

#include "nest.h"
#include "graph.h"

#include "defs.h"
#include "simulate.h"
#include "process.h"

static timev    moment = {0, 0};

/*
 * Return a node list of all neighbors
 */

node_ptr        get_neighbors (nodeid)
ident           nodeid;
{
    node_ptr        _get_nbrs ();
    node_ptr        result;


    hold ();
    if (_stop_timer (moment))           /* stop the clock while we work */
        fatal ("get_neighbors: stop_timer: ");

    if (nodeid > Nodes)
    {
        (void) _complain ("get_neighbors : bad nodeid - assuming current node");
        nodeid = 0;
    }

    result = _get_nbrs (nodeid ? nodeid : _current_node);

    if (_start_timer (time_zero))       /* start clock again and return */
        fatal ("get_neighbors: start_timer: ");
    release (1);

    return (result);
}
