/*
 * Nest simulation library - process routines
 * 
 * $Header: procs.c,v 2.5 88/03/31 14:49:55 dupuy Rel $
 */

#include "nest.h"

#include "defs.h"
#include "simulate.h"
#include "process.h"

/* Global */

process *_proc_table;            /* size of `nodes' arg to simulate() */

/* Initialization and maintenance of process table */

nest_proc_init (nodes)
ident           nodes;
{
    _proc_table = newarray (nodes + 1, process);

    _sync_time.tv_usec = 10000;         /* were this zero, we'd never start */
}


nest_proc_start (nodeid)
ident           nodeid;
{
    register process *proc;

    proc = &(_proc_table[nodeid]);

    if (Logging)
        (void) printf ("starting node %d\n", nodeid);

    proc->unblocked = _sync_time;
    proc->runtime = _sync_time;
    proc -> stopcount = 0;
    proc -> holdcount = 0;

    _remove_sched (nodeid, DoneQueue);
    _newpass_add (nodeid);
}


nest_proc_run (nodeid, proc)
ident           nodeid;
reg process    *proc;
{
    if (proc->function)                 /* shouldn't ever be nil, but... */
    {
        proc->stopcount = proc->holdcount = 0;

        _running = proc->started = true;

        release (0);                    /* enable timer signals */
        (*proc->function) (nodeid);     /* start the process running */
        hold ();                        /* disable timer signals */
    }

    proc->started = _running = false;
}

