/*
 * Nest simulation library - receive message routine
 *
 * $Header: recvm.c,v 2.5 88/03/31 14:49:59 dupuy Rel $
 */

#include "nest.h"

#include "defs.h"
#include "simulate.h"
#include "message.h"
#include "process.h"

ident
recvm (destp, keyp, dataptrp)		/* returns sending node */
    ident          *destp;	/* gets dest of initial sendm() call */
    long           *keyp;	/* gets message code (user defined) */
    char          **dataptrp;	/* gets ptr to message data on heap */
{
    ident           sender;
    register message *msg_ptr;


    hold ();
    _timers = false;
    if (_message_table[_current_node] is nil)
    {				/* block indefinitely if no messages */
	if (_block (time_zero, RECEIVE))
	    fatal ("recvm: block(0): ");
    }
    /* get the earliest message which exists (should be a separate
     * function) */

    msg_ptr = _message_table[_current_node]->msg;

    if (time_after (msg_ptr->arrived, _proc_table[_current_node].runtime))
    {				/* block until that message arrives */
	if (_block (msg_ptr->arrived, RECEIVE))
	    fatal ("recvm: block(1): ");
    } else
    {				/* block until present time */
	if (_block (_proc_table[_current_node].runtime, RECEIVE))
	    fatal ("recvm: block(2): ");
    }


    /* get the first message which arrives (it may have changed) */

    msg_ptr = _message_table[_current_node]->msg;

    /* we reach here only if a message exists, and has arrived already */

    /* set up recvm's argument variables */

    sender = msg_ptr->sender;	/* temporary value for return() */

    *destp = msg_ptr->dest;

    *keyp = msg_ptr->key;

    *dataptrp = msg_ptr->dataptr;

    report (("%d got message [%d] from %d to %d\n",
	     _current_node, *keyp, sender, *destp));

    /* remove the message from the message list */

    _drop_message (&_message_table[_current_node]);

    if (_start_timer (time_zero))	/* start the clock again */
	fatal ("recvm: start_timer: ");
    release (1);

    return (sender);		/* return the message's sender */
}
