/*
 * Nest simulation library - sleep routine for node functions
 * 
 * $Header: slumber.c,v 2.5 88/03/31 14:50:33 dupuy Rel $
 */

#include "nest.h"

#include "defs.h"
#include "simulate.h"
#include "process.h"

/*
 * Simulate a sleep for fractional (or more) seconds
 */

slumber (naptime, wakeup)
timev          *naptime;
flag            wakeup;
{
    timev           time_temp;
    timev          *arrived;


    hold ();
    _timers = 0;
    if (naptime is nil)                 /* treat nil as indefinite sleep */
        time_temp = time_zero;
    else                                /* convert sleep time to wakeup time */
    {
        time_temp = _proc_table[_current_node].runtime;

        time_add (time_temp, *naptime);
    }

    if (wakeup)                         /* check for future pending messages */
    {
        arrived = _check_queue (_current_node,
                                &_proc_table[_current_node].runtime,
                                naptime ? &time_temp : nil);

        if (arrived isnt nil and time_after (time_temp, *arrived))
            time_temp = *arrived;
    }

    if (_block (time_temp, (wakeup ? WAIT : SLEEP)))
        fatal ("slumber: block: ");


    if (_start_timer (time_zero))       /* start the clock again and return */
        fatal ("slumber: start_timer: ");
    release (1);

    return (not time_equal (time_temp, _proc_table[_current_node].unblocked));
}
